/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <math.h>
#include  "mtk_mode.h"
#include  "mtk_stars_2.h"
#include  "mtk_stars.h"
#include  "mtk_objects.h"
#include  "mtk_label.h"
#include  "mtk_colors.h"
#include  "mtk_switches.h"
#include  "mtk_solar_system.h"
#include  "mtk_font.h"
#include  "mtk_gl_common.h"
#include  "mtk_calc_alpha.h"
#include  "../common/astro/constellation.h"
#include  "../common/astro/star_name.h"
#include  <vector>


//**********
extern float  StarImagePowIndex;
extern GLuint  dlStar;
extern GLuint  texStar;
//**********



static float  Lv0;	// ̊̖邳




//------------
//  Register
//------------
void
register_object_stars()
{
	mtk_object  obj;
	for (int i=0; i<get_stars_num(); i++) {
		const mtk_star&  st = get_star(i);


		//--  Register a star
		char key[256];
		sprintf(key, "HIP%d", st.get_HIP());
		obj.init(OBJ_TYPE_STAR, i, 0.0f, true);
		int obj_ID = register_object(obj, key);


		//--  Register labels
		char key2[256];
		sprintf(key2, "%sLabel", key);

		//*******
		float R = 0;
		float thc = 8 * D2R;
		//*******
		add_label( "", "", obj_ID, MTK_COLOR_NAME_OBJECT, 1.0f, get_object_name_size(), R, thc, true, key2 );
	}
}





inline double 
get_star_radius(const mtk_draw_struct& ds, int idx)
{
	//  Radius
	const mtk_star&  st = get_star(idx);
	const double& L = st.get_L();

	double dist2 = norm2(st.get_pos() - ds.camera.get_pos());
	double dist  = sqrt(dist2);

	const double R1 = 9.0e-4;	// P 1pc ł̃C[Wa
	return  pow(Lv0*L/dist2, double(StarImagePowIndex)) * R1 * dist;
}





//------------------
//  Landing radius
//------------------
double
get_landing_radius_star(int idx)
{
	return  0.1 * _1AU_pc;		//*****
}


//----------------
//  Prepare draw
//----------------
bool
prepare_draw_star(const mtk_draw_struct& ds, int idx, double* pRb, double* pRh)
{
	if  ( !(swStar & STAR_DISP) )  return  false;
	if (ds.cnorm > 1.5e5)  return false;

	*pRh = *pRb = get_star_radius(ds, idx);
	return  true;
}



//---------
//  Scale
//---------
double
get_scale_star(int idx)
{
	//  Radius
	const mtk_star&  st = get_star(idx);
	const double& L = st.get_L();
	const double R1 = 9.0e-4;	// P 1pc ł̃C[Wa

	return  sqrt(Lv0*L) * pow(100*R1, 1.0/(2.0*double(StarImagePowIndex)));
}



//---------
//  Label
//---------
const double star_lc1 = 0.6;
const double star_lc2 = 1.5;


bool
is_star_label_visible(const mtk_draw_struct& ds, int idx)
{
	if ( !(swStar & STAR_DISP) )  return false; 
	if ( !(swStar & (STAR_NAME | STAR_BAYER | STAR_FRAMSTEED | STAR_HIP)) )  return false;
	if (ds.cnorm > 1.5e5)  return false;

	const mtk_star& st = get_star(idx);
	const char* name_L = st.get_name_L();
	const char* name_S = st.get_name_S();
	const bool bNameLarge = (name_L[0] != '\0');
	const bool bNameSmall = (name_S[0] != '\0');
	if (!bNameLarge && !bNameSmall)		return false;	// \閼Oꍇ

	if (ds.cnorm < star_lc1)  return  false;

	return  true;
}


float
get_star_label_alpha(const mtk_draw_struct& ds, int idx)
{
	const double lc = ds.cnorm;
	if (lc < star_lc2) {
		return  (lc - star_lc1) / (star_lc2 - star_lc1);
	}

	float scl = 0.5f;
	const vector3d  spos = get_star_position(idx);
	const vector3d  cpos = ds.camera.get_pos();
	const vector3d  rpos = spos - cpos;
	const double ls = spos.norm();
	float  Rv = scl * ls;
	float  Dth = 2.0f * Rv / rpos.norm();

	return  calc_alpha_by_apparent_diameter( Dth );
}





//-------------
//  Draw name
//-------------
void
draw_a_star_label(const mtk_draw_struct& ds, int idx)
{
	const mtk_star& st = get_star(idx);
	const char* name_L = st.get_name_L();
	const char* name_S = st.get_name_S();
	const bool bNameLarge = (name_L[0] != '\0');
	const bool bNameSmall = (name_S[0] != '\0');

	if (bNameLarge) {
		draw_text(name_L);
	}

	if (bNameSmall) {
		const float f = 4.0/5.0;
		glScalef(f,f,f);

		if (bNameLarge)		draw_textf("(%s)", name_S);
		else				draw_text(name_S);
	}
}


float
get_star_label_size(int idx)
{
	const mtk_star& st = get_star(idx);
	const char* name_L = st.get_name_L();
	const char* name_S = st.get_name_S();
	const bool bNameLarge = (name_L[0] != '\0');
	const bool bNameSmall = (name_S[0] != '\0');
	if (!bNameLarge && !bNameSmall)		return 0.0;	// \閼Oꍇ

	float w1, w2, h;
	get_text_size(name_L, w1, h);
	get_text_size(name_S, w2, h);

	return  w1 + 4.0/5.0*w2;
}



//----------------
//  Prepare draw
//----------------

//***  prepare_draw_objects ̑OɌĂ  ***
void
prepare_draw_stars_2(const float scale)
{
	const float L0 = 35000;
	const float scl0 = 500.0f;

	//  ̖邳̐ݒ(XP[ˑj
	float amp = 1;
	if (scale > scl0) {
		float a = 4*log10(scale/scl0);
		amp *= (1 + a*a);
	}
	Lv0 = amp * L0 / get_L_ref();
}







//--------
//  Draw
//--------
void
draw_star_mark_3D(float sz)
{
	glDisable(GL_TEXTURE_2D);
	glPushMatrix();
		glScalef(sz, sz, sz);
		glBegin(GL_LINE_LOOP);
			glVertex3f(-1,-1,0);
			glVertex3f(1,-1,0);
			glVertex3f(1,1,0);
			glVertex3f(-1,1,0);
		glEnd();
	glPopMatrix();
	glEnable(GL_TEXTURE_2D);
}


void
draw_a_star(const mtk_draw_struct& ds, int idx, const vector3d& rpos, const double& scl, const double& Rb, float alp, bool bChangeObjType)
{
	const mtk_star& st = get_star(idx);
	const float R = 1.5 * scl * Rb;



	//*****  擾KvH
	int  TempIdx = get_star_picture().get_TempIdx(st.get_Tc());

	//----------------------
	//  Textured billboard
	//----------------------
	if (bChangeObjType) {
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glDepthMask(GL_FALSE);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE);
		glBindTexture(GL_TEXTURE_2D, texStar);
	}

	glPushMatrix();
		glTranslatef( rpos.x, rpos.y, rpos.z );
			
		
		// ʂ̌ݒ肷
		toward_eye_pos2();

		glScalef(R,R,1);
		glColor3f(alp,alp,alp);
		
		glCallList(dlStar + TempIdx);

		if (tyStarMark == STARMARK_DOUBLE && st.is_double()) {
			glColor4f(0,1,0,alp);
			glLineWidth( 0.5 / (ds.rad_per_pixel / 0.001) );
			draw_star_mark_3D(1.2);
		}

		if (tyStarMark == STARMARK_EXOPLANETS && has_exoplanet(st.get_HIP())) {
			glColor4f(1,0.9,0,alp);
			glLineWidth( 3.5 / (ds.rad_per_pixel / 0.001) );
			draw_star_mark_3D(2);
		}
	glPopMatrix();
}





//--------
//  Info
//--------
void
make_object_info_star(const mtk_draw_struct& ds, int idx, std::vector<std::string>& text)
{
	bool bEnglish = (ds.lang == LANG_ENG);
	char name2[256], str[256];

	const mtk_star& st = get_star(idx);


	//-- oCGAtX`[hL̕\
	int BayerID = st.get_BayerID();
	int BayerSub = st.get_BayerSub();
	int Framsteed = st.get_FramsteedNo();
	int ADScomp = st.get_ADScomp();
	const char* szCnst = get_constellation_abbr( st.get_cnst_ID() );

	if (BayerID != -1) {
		const char* szBayer = get_Greek_letter_J(BayerID);
		char szBayer2[10];
		if (BayerSub != -1)		{ sprintf(szBayer2, "%s^%1d",	szBayer, BayerSub); }
		else					{ sprintf(szBayer2, "%s",		szBayer); }

		if (Framsteed!=-1)		{ sprintf(str, "%d%s%s", Framsteed, szBayer2, szCnst); }
		else					{ sprintf(str, "%s%s",	 szBayer2, szCnst); }
	} else if (Framsteed != -1) {
		sprintf(str, "%d %s", Framsteed, szCnst);
	} else {
		str[0] = '\0';
	}
	
	if (str[0] != '\0') {
		if (ADScomp!=' ')		{ sprintf(name2, "%s%c", str, ADScomp); }
		else					{ strcpy(name2, str); }
	} else {
		name2[0] = '\0';
	}





	const char* name = st.get_proper_name(bEnglish);
	if (name != 0) {
		text.push_back( name );
		text.push_back( name2 );
	} else {
		if (name2[0] != '\0') {
			text.push_back( name2 );
		} else {
			sprintf(str, "HIP%d", st.get_HIP());
			text.push_back(str);
		}
	}


	if (bEnglish) {
		text.push_back( "Type: Star" );
		sprintf(str, "HIP Number: %d", st.get_HIP());
		text.push_back(str);
	} else {
		text.push_back( "ށFP" );
		sprintf(str, "HIP ԍF%d", st.get_HIP());
		text.push_back(str);
	}
}
