/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_triangle_mesh.h"
#include  <algorithm>
#include  "../common/math/vector3.h"


const int vtxn_max = TRIANGLE_VTX_MAX;
static int vtxn = 0;
static Triangle vTri[4*vtxn_max + 10];
static vector2f vVtx[vtxn_max];
static std::vector<xlist>  vXlist(vtxn_max);


void
clear_triangle_vtx()
{
	vtxn = 0;
}

void
add_triangle_xy(float x, float y)
{
	if (vtxn >= vtxn_max)  return;
	vXlist[vtxn].ID = vtxn;
	vXlist[vtxn].x  = x;
	vXlist[vtxn].y  = y;
	vtxn++;
}

int
triangulation()
{
	std::sort(vXlist.begin(), vXlist.begin() + vtxn);

	for (int i=0; i<vtxn; i++) {
		vVtx[i].x = vXlist[i].x;
		vVtx[i].y = vXlist[i].y;
	}
	
	int nTri = DelaunayTriangulation(vtxn, vVtx, vTri);
	if (nTri <= 0)  return 0;

	for (int i=0; i<nTri; i++) {
		Triangle&  tri = vTri[i];

		for (int j=0; j<3; j++) {
			int idx = tri.p[j];
			tri.p[j] = vXlist[idx].ID; 
		}
	}

	return  nTri;
}

Triangle*
get_triangle_list()
{
	return vTri;
}

std::vector<xlist>&
get_xlist()
{
	return  vXlist;
}
